#  Copyright (C) 1999-2012
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc HelpDef {} {
    global help
    global ds9

    set help(refman) "$ds9(doc)/ref/index.html"
    set help(command) "$ds9(doc)/ref/command.html"
    set help(userman) "$ds9(doc)/user/index.html"
    set help(keyboard) "$ds9(doc)/ref/keyboard.html"
    set help(faq) "$ds9(doc)/faq.html"
    set help(new) "$ds9(doc)/new.html"
    set help(release) "$ds9(doc)/release/r7.0.html"
    set help(helpdesk) "$ds9(doc)/helpdesk.html"
    set help(story) "$ds9(doc)/story.html"
    set help(ack) "$ds9(doc)/acknowledgment.html"
    set help(vo) "$ds9(doc)/ref/vo.html"

    set help(about) "SAOImage DS9\nVersion $ds9(version)\n\nAuthors:\nWilliam Joye (Smithsonian Astrophysical Observatory)\nEric Mandel (Smithsonian Astrophysical Observatory)\nSteve Murray (Johns Hopkins University)\nJohn Roll (Smithsonian Astrophysical Observatory)\n\nTranslations:\nHans-Jakob Grimm (Smithsonian Astrophysical Observatory)\nAllan Hornstrup (Danmarks Tekniske Universitet)\nAlberto Martins (Universidade de Sao Paulo)\nManuel Perez Torres (Smithsonian Astrophysical Observatory)\nMasahiro Tsujimoto (Japan Aerospace Exploration Agency)\nPetr Kubnek (Institute of Physics, Prague)\nAlbert Kong (National Tsing Hua University)\nHao-Yuan Duan (National Tsing Hua University)\n\nSAOImage DS9 development has been made possible by funding from the Chandra X-ray Science Center (CXC) and the High Energy Astrophysics Science Archive Center (HEASARC). Additional funding was provided by the JWST Mission office at Space Telescope Science Institute to improve capabilities for 3-D data visualization."

    append help(about) "\n\nDebian packaging:\nOle Streicher (AIP)"

    set help(email) "If you encounter any problems or have suggestions with ds9, please contact us at: 

saord@cfa.harvard.edu
http://hea-www.harvard.edu/RD/ds9/

William Joye
Eric Mandel
Smithsonian Astrophysical Observatory
Garden St.
Cambridge, MA 02138 USA"

    set help(shortcuts) " DS9 version $ds9(version)\n\n\
          Key Stroke       Description\n\
          ----------       -----------\n\
          TAB              Goto next frame\n\
          DELETE           Deletes selected regions\n\
          R                Print Mouse Coordinates and Pixel value.\n\
          F                Toggles Infobox freeze\n\
          I                Set include property for region\n\
          E                Set exclude property for region\n\
          S                Set source property for region\n\
          B                Set background property for region\n\
          +                Goto next 3D Fits Slice\n\
          -                Goto previous 3D Fits Slice\n\
          Up Arrow         Move selected regions/cursor up one pixel.\n\
          Right Arrow      Move selected regions/cursor right one pixel.\n\
          Left Arrow       Move selected regions/cursor left one pixel.\n\
          Down Arrow       Move selected regions/cursor down one pixel.\n\
          Shift-Drag       Select all regions within the indicated region.\n\
          Control-Drag     Selected ANNULUS Regions, will create new radii.\n
"

}

proc HelpRef {} {
    global help
    HV hlpref [msgcat::mc {Reference Manual}] $help(refman)
}

proc HelpCommand {} {
    global help
    HV hlpcmd [msgcat::mc {Command}] $help(command)
}

proc HelpUser {} {
    global help
    HV hlpuser [msgcat::mc {User Manual}] $help(userman)
}

proc HelpKeyboard {} {
    global help
    HV hlpkeyboard [msgcat::mc {Keyboard Shortcuts}] $help(keyboard)
}

proc HelpFAQ {} {
    global help
    HV hlpfaq [msgcat::mc {FAQ}] $help(faq)
}

proc HelpNew {} {
    global help
    HV hlpnew [msgcat::mc {New Features}] $help(new)
}

proc HelpRelease {} {
    global help
    HV hlprelease [msgcat::mc {Release Notes}] $help(release)
}

proc HelpDesk {} {
    global help
    HV hlpdsk [msgcat::mc {Help Desk}] $help(helpdesk)
}

proc HelpStory {} {
    global help
    HV hlpstory [msgcat::mc {Story of SAOImage DS9}] $help(story)
}

proc HelpAck {} {
    global help
    HV hlpack [msgcat::mc {Acknowledgment}] $help(ack)
}

proc HelpVO {} {
    global help
    HV hlvo [msgcat::mc {Virtual Observatory}] $help(vo)
}

proc ProcessSendAboutCmd {proc id param sock fn} {
    global help 
    ProcessSend $proc $id $sock $fn {.txt} "$help(about)\n"
}
